#include <p32xxxx.h>
#include <plib.h>
#include "..\APP2013TM_LCM.h"

// [JTLinker Script File, {\񪺦m
// iHTftBootloaderC

#define SystemFrequency			80000000L
#define PBFrequency				SystemFrequency / 8
#define Timer1Tick				( PBFrequency / 256 / Timer1TogglesPerSec )
#define Timer1TogglesPerSec		10
#define Timer3Tick				( PBFrequency / 4 / Timer3TogglesPerSec )
#define Timer3TogglesPerSec		50

volatile unsigned int VR1Value = 0;
volatile unsigned int ADCDone = 0;

// إTimer1_AȨ禡AëwDn_uv4C

void __ISR(_TIMER_1_VECTOR, ipl4) ISR_Timer1(void)
{
    // MTimer_XСC
    INTClearFlag(INT_T1);

    // IO PortA(Toggle)C
    mPORTBToggleBits(BIT_13);
}

// To Do : إADC_AȨ禡AëwDn_uv5C

void __ISR(_ADC_VECTOR, ipl5) ISR_ADC(void)
{
    // To Do : ADC Buffer 0ŪADCഫƭȡC
    VR1Value = (unsigned int) ReadADC10(0);

    // To Do : MADC1_X
    INTClearFlag(INT_AD1);

	ADCDone = 1;
}

void main(void)
{
    // Disable the JTAG function
    DDPCONbits.JTAGEN = 0;

    // ϥXC32OSCConfig FunctionA
    // ʺAMCUtήɯ߬Primary Oscillator With PLL (80MHz)C
    OSCConfig(OSC_POSC_PLL, OSC_PLL_MULT_20, OSC_PLL_POST_1, 0);

    // ϥXC32OSCSetPBDIV FunctionA
    // ʺASystem ClockPB Clockv1:8C
    OSCSetPBDIV(OSC_PB_DIV_8);

    // ϥXC32SYSTEM ConfigƱNWait StatePPrefetch̨ΤơC
    SYSTEMConfig(SystemFrequency, SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE);

    // ϥXC32 I/O Prot FunctionNLEDI/O]wƦXAëwI/O PortAC
    mPORTBSetPinsDigitalOut(BIT_13); // D5
    mPORTBClearBits(BIT_13);

    // ϥXC32 OpenTimer1 Function ]wTimer1C
    OpenTimer1(T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT, Timer1Tick);

    // ϥXC32 ConfigIntTimer1 FunctionҥTimer1_
    // ëwDn_uv4Anuv0C
    ConfigIntTimer1(T1_INT_ON | T1_INT_PRIOR_4 | T1_INT_SUB_PRIOR_0);

    // To Do : ϥXC32 OpenADC10 Function]wADC (ADC_CLK_MANUAL -> ADC_CLK_TMR)C
    OpenADC10(ADC_MODULE_ON | ADC_IDLE_CONTINUE | ADC_FORMAT_INTG16 | ADC_CLK_TMR | ADC_AUTO_SAMPLING_ON | ADC_SAMP_OFF,
              ADC_VREF_AVDD_AVSS | ADC_OFFSET_CAL_DISABLE | ADC_SCAN_OFF | ADC_SAMPLES_PER_INT_1 | ADC_ALT_BUF_OFF | ADC_ALT_INPUT_OFF,
              ADC_SAMPLE_TIME_31 | ADC_CONV_CLK_SYSTEM | ADC_CONV_CLK_32Tcy,
              ENABLE_AN11_ANA, SKIP_SCAN_ALL);

    //  ϥXC32 SetChanADC10 Function]wADT,tqD( (+)AN11 , (-)VREF- )C
    SetChanADC10(ADC_CH0_POS_SAMPLEA_AN11 | ADC_CH0_NEG_SAMPLEA_NVREF | ADC_CH0_POS_SAMPLEB_AN0 | ADC_CH0_NEG_SAMPLEB_NVREF);
    // *MPLAB XC v1.21e(t), ADC_CHx_POS_SAMPLEx_ANxx, ADC_CHx_NEG_SAMPLEx_xxxxx ثeu䴩 AN0 - AN15,
    // AN16ثegȦs.
    // Example : AD1CHS = 0x001A0000; //AN26,VREFL,AN0,VREFL

    // To Do : ϥXC32 OpenTimer3 Function ]wTimer3C
    OpenTimer3(T3_ON | T3_IDLE_CON | T3_GATE_OFF | T3_PS_1_4 | T3_SOURCE_INT, Timer3Tick);

    // To Do : ϥXC32 ConfigIntADC10 FunctionҥADC_
    //		   ëwDn_uv5Anuv0C
    ConfigIntADC10(ADC_INT_ON | ADC_INT_PRI_5 | ADC_INT_SUB_PRI_0);

    // ϥXC32 INTEnableSystemMultiVectoredInt Function
    // ]wPIC32h_VqҦC
    INTEnableSystemMultiVectoredInt();

    // LCMlơC
    LCM_Init();

    // ]wCСAXrC
    LCM_SetCursor(0, 0);
    LCM_PutROMString((unsigned char *) "PIC32MX450F256H ");
    LCM_SetCursor(0, 1);
    LCM_PutROMString((unsigned char *) "VR1:            ");

    while (1)
    {
        if (ADCDone)
        {
            ADCDone = 0;

            // ]wCСAXADCƭȡC
            LCM_SetCursor(4, 1);
            LCM_PutNumber(VR1Value, 4);
        }
    }

    while (1);
}
